## percona-server-mongodb 3.0.5

=== SConstruct ===
# -*- mode: python; -*-
# build file for MongoDB
# this requires scons
# you can get from http://www.scons.org
# then just type scons

# some common tasks
#   build 64-bit mac and pushing to s3
#      scons --64 s3dist
#      scons --distname=0.8 s3dist
#      all s3 pushes require settings.py and simples3

# This file, SConstruct, configures the build environment, and then delegates to
# several, subordinate SConscript files, which describe specific build rules.

import buildscripts
import copy
import datetime
import imp
import errno
import json
import os
import re
import shlex
import shutil
import stat
import sys
import textwrap
import types
import urllib
import urllib2
import uuid
from buildscripts import utils
from buildscripts import moduleconfig

import libdeps

EnsureSConsVersion( 2, 3, 0 )

def findSettingsSetup():
    sys.path.append( "." )
    sys.path.append( ".." )
    sys.path.append( "../../" )

def versiontuple(v):
    return tuple(map(int, (v.split("."))))

# --- platform identification ---
#
# This needs to precede the options section so that we can only offer some options on certain
# platforms.

platform = os.sys.platform
nix = False
linux = False
darwin = False
windows = False
freebsd = False
openbsd = False
solaris = False

if "darwin" == platform:
    darwin = True
    platform = "osx" # prettier than darwin
elif platform.startswith("linux"):
    linux = True
    platform = "linux"
elif "sunos5" == platform:
    solaris = True
elif platform.startswith( "freebsd" ):
    freebsd = True
elif platform.startswith( "openbsd" ):
    openbsd = True
elif "win32" == platform:
    windows = True
else:
    print( "No special config for [" + platform + "] which probably means it won't work" )

nix = not windows

# --- options ----
use_clang = False

options = {}

def add_option( name, help, nargs, contributesToVariantDir,
                dest=None, default = None, type="string", choices=None, metavar=None, const=None ):

    if dest is None:
        dest = name

    if type == 'choice' and not metavar:
        metavar = '[' + '|'.join(choices) + ']'

    AddOption( "--" + name , 
               dest=dest,
               type=type,
               nargs=nargs,
               action="store",
               choices=choices,
               default=default,
               metavar=metavar,
               const=const,
               help=help )

    options[name] = { "help" : help ,
                      "nargs" : nargs ,
                      "contributesToVariantDir" : contributesToVariantDir ,
                      "dest" : dest,
                      "default": default }

def get_option( name ):
    return GetOption( name )

def has_option( name ):
    x = get_option( name )
    if x is None:
        return False

    if x == False:
        return False

    if x == "":
        return False

    return True

def use_system_version_of_library(name):
    return has_option('use-system-all') or has_option('use-system-' + name)

def skip_buildinfo():
    return has_option('skip-buildinfo')

# Returns true if we have been configured to use a system version of any C++ library. If you
# add a new C++ library dependency that may be shimmed out to the system, add it to the below
# list.
def using_system_version_of_cxx_libraries():
    cxx_library_names = ["tcmalloc", "boost", "v8"]
    return True in [use_system_version_of_library(x) for x in cxx_library_names]

def get_variant_dir():

    build_dir = get_option('build-dir').rstrip('/')

    if has_option('variant-dir'):
        return (build_dir + '/' + get_option('variant-dir')).rstrip('/')

    substitute = lambda x: re.sub( "[:,\\\\/]" , "_" , x )

    a = []

    for name in options:
        o = options[name]
        if not has_option( o["dest"] ):
            continue
        if not o["contributesToVariantDir"]:
            continue
        if get_option(o["dest"]) == o["default"]:
            continue

        if o["nargs"] == 0:
            a.append( name )
        else:
            x = substitute( get_option( name ) )
            a.append( name + "_" + x )

    extras = []
    if has_option("extra-variant-dirs"):
        extras = [substitute(x) for x in get_option( 'extra-variant-dirs' ).split( ',' )]

    if has_option("add-branch-to-variant-dir"):
        extras += ["branch_" + substitute( utils.getGitBranch() )]

    if has_option('cache'):
        s = "cached"
        s += "/".join(extras) + "/"
    else:
        s = "${PYSYSPLATFORM}/"
        a += extras

        if len(a) > 0:
            a.sort()
            s += "/".join( a ) + "/"
        else:
            s += "normal/"

    return (build_dir + '/' + s).rstrip('/')

# build output
add_option( "mute" , "do not display commandlines for compiling and linking, to reduce screen noise", 0, False )

# installation/packaging
add_option( "prefix" , "installation prefix" , 1 , False, default='$BUILD_ROOT/install' )
add_option( "distname" , "dist name (0.8.0)" , 1 , False )
add_option( "distmod", "additional piece for full dist name" , 1 , False )
add_option( "distarch", "override the architecture name in dist output" , 1 , False )
add_option( "nostrip", "do not strip installed binaries" , 0 , False )
add_option( "extra-variant-dirs", "extra variant dir components, separated by commas", 1, False)
add_option( "add-branch-to-variant-dir", "add current git branch to the variant dir", 0, False )
add_option( "build-dir", "build output directory", 1, False, default='#build')
add_option( "variant-dir", "override variant subdirectory", 1, False )

# linking options
add_option( "release" , "release build" , 0 , True )
add_option( "static" , "fully static build" , 0 , False )
add_option( "static-libstdc++" , "statically link libstdc++" , 0 , False )
add_option( "lto", "enable link time optimizations (experimental, except with MSVC)" , 0 , True )
add_option( "dynamic-windows", "dynamically link on Windows", 0, True)

# base compile flags
add_option( "64" , "whether to force 64 bit" , 0 , True , "force64" )
add_option( "32" , "whether to force 32 bit" , 0 , True , "force32" )

add_option( "endian" , "endianness of target platform" , 1 , False , "endian",
            type="choice", choices=["big", "little", "auto"], default="auto" )

add_option( "cxx", "compiler to use" , 1 , True )
add_option( "cc", "compiler to use for c" , 1 , True )
add_option( "cc-use-shell-environment", "use $CC from shell for C compiler" , 0 , False )
add_option( "cxx-use-shell-environment", "use $CXX from shell for C++ compiler" , 0 , False )
add_option( "ld", "linker to use" , 1 , True )
add_option( "c++11", "enable c++11 support (experimental)", "?", True,
            type="choice", choices=["on", "off", "auto"], const="on", default="auto" )
add_option( "disable-minimum-compiler-version-enforcement",
            "allow use of unsupported older compilers (NEVER for production builds)",
            0, False )

add_option( "cpppath", "Include path if you have headers in a nonstandard directory" , 1 , False )
add_option( "libpath", "Library path if you have libraries in a nonstandard directory" , 1 , False )

add_option( "extrapath", "comma separated list of add'l paths  (--extrapath /opt/foo/,/foo) static linking" , 1 , False )
add_option( "extrapathdyn", "comma separated list of add'l paths  (--extrapath /opt/foo/,/foo) dynamic linking" , 1 , False )
add_option( "extralib", "comma separated list of libraries  (--extralib js_static,readline" , 1 , False )

# experimental features
add_option( "mm", "use main memory instead of memory mapped files" , 0 , True )
add_option( "ssl" , "Enable SSL" , 0 , True )
add_option( "rocksdb" , "Enable RocksDB" , 0 , False )
add_option( "wiredtiger", "Enable wiredtiger", "?", True, "wiredtiger",
            type="choice", choices=["on", "off"], const="on", default="on")
add_option( "PerconaFT" , "Enable PerconaFT" , 0 , False )
add_option( "audit" , "Enable auditing" , 0 , False )

# library choices
js_engine_choices = ['v8-3.12', 'v8-3.25', 'none']
add_option( "js-engine", "JavaScript scripting engine implementation", 1, False,
           type='choice', default=js_engine_choices[0], choices=js_engine_choices)
add_option( "libc++", "use libc++ (experimental, requires clang)", 0, True )

add_option( "use-glibcxx-debug",
            "Enable the glibc++ debug implementations of the C++ standard libary", 0, True )

# mongo feature options
add_option( "noshell", "don't build shell" , 0 , True )
add_option( "safeshell", "don't let shell scripts run programs (still, don't run untrusted scripts)" , 0 , True )
add_option( "win2008plus",
            "use newer operating system API features (deprecated, use win-version-min instead)" ,
            0 , False )

# dev options
add_option( "d", "debug build no optimization, etc..." , 0 , True , "debugBuild" )
add_option( "dd", "debug build no optimization, additional debug logging, etc..." , 0 , True , "debugBuildAndLogging" )

# new style debug and optimize flags
add_option( "dbg", "Enable runtime debugging checks", "?", True, "dbg",
            type="choice", choices=["on", "off"], const="on" )

add_option( "opt", "Enable compile-time optimization", "?", True, "opt",
            type="choice", choices=["on", "off"], const="on" )

add_option( "profiling", "Allow profiling and debugging", "?", True, "profiling",
            default="on", type="choice", choices=["on", "off"], const="on" )

add_option( "sanitize", "enable selected sanitizers", 1, True, metavar="san1,san2,...sanN" )
add_option( "llvm-symbolizer", "name of (or path to) the LLVM symbolizer", 1, False, default="llvm-symbolizer" )

add_option( "durableDefaultOn" , "have durable default to on" , 0 , True )
add_option( "durableDefaultOff" , "have durable default to off" , 0 , True )

add_option( "pch" , "use precompiled headers to speed up the build (experimental)" , 0 , True , "usePCH" )
add_option( "distcc" , "use distcc for distributing builds" , 0 , False )

# debugging/profiling help
if os.sys.platform.startswith("linux") or os.sys.platform == "win32":
    defaultAllocator = 'tcmalloc'
else:
    defaultAllocator = 'system'
add_option( "allocator" , "allocator to use (tcmalloc or system)" , 1 , True,
            default=defaultAllocator )
add_option( "gdbserver" , "build in gdb server support" , 0 , True )
add_option( "heapcheck", "link to heap-checking malloc-lib and look for memory leaks during tests" , 0 , False )
add_option( "gcov" , "compile with flags for gcov" , 0 , True )

add_option("smokedbprefix", "prefix to dbpath et al. for smoke tests", 1 , False )
add_option("smokeauth", "run smoke tests with --auth", 0 , False )

add_option("use-sasl-client", "Support SASL authentication in the client library", 0, False)

add_option( "use-system-tcmalloc", "use system version of tcmalloc library", 0, True )

add_option( "use-system-pcre", "use system version of pcre library", 0, True )

add_option( "use-system-wiredtiger", "use system version of wiredtiger library", 0, True)

# library choices
boost_choices = ['1.49', '1.56']
add_option( "internal-boost", "Specify internal boost version to use", 1, True,
           type='choice', default=boost_choices[0], choices=boost_choices)

add_option( "system-boost-lib-search-suffixes",
            "Comma delimited sequence of boost library suffixes to search",
            1, False )

add_option( "use-system-boost", "use system version of boost libraries", 0, True )

add_option( "use-system-snappy", "use system version of snappy library", 0, True )

add_option( "use-system-zlib", "use system version of zlib library", 0, True )

add_option( "use-system-v8", "use system version of v8 library", 0, True )

add_option( "use-system-stemmer", "use system version of stemmer", 0, True )

add_option( "use-system-yaml", "use system version of yaml", 0, True )

add_option( "use-system-all" , "use all system libraries", 0 , True )

# deprecated
add_option( "use-new-tools" , "put new tools in the tarball", 0 , False )

add_option( "use-cpu-profiler",

=== src/third_party/PerconaFT/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.8 FATAL_ERROR)
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake_modules")

project(TokuDB)

# suppress -rdynamic
set(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "")
set(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS "")

## Versions of gcc >= 4.9.0 require special version of 'ar' and 'ranlib' for
## link-time optimizations to work properly.
##
## From https://gcc.gnu.org/gcc-4.9/changes.html:
##
##     When using a linker plugin, compiling with the -flto option now
##     generates slim objects files (.o) which only contain intermediate
##     language representation for LTO. Use -ffat-lto-objects to create
##     files which contain additionally the object code. To generate
##     static libraries suitable for LTO processing, use gcc-ar and
##     gcc-ranlib; to list symbols from a slim object file use
##     gcc-nm. (Requires that ar, ranlib and nm have been compiled with
##     plugin support.)
if ((CMAKE_CXX_COMPILER_ID STREQUAL GNU) AND
    NOT (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.9.0"))
  find_program(gcc_ar "gcc-ar")
  if (gcc_ar)
    set(CMAKE_AR "${gcc_ar}")
  endif ()
  find_program(gcc_ranlib "gcc-ranlib")
  if (gcc_ranlib)
    set(CMAKE_RANLIB "${gcc_ranlib}")
  endif ()
endif()

include(TokuFeatureDetection)
include(TokuSetupCompiler)
include(TokuSetupCTest)
include(TokuThirdParty)

set(TOKU_CMAKE_SCRIPT_DIR "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(TokuMergeLibs)

## need a way to change the name of libs we build
set(LIBTOKUPORTABILITY "tokuportability" CACHE STRING "Name of libtokuportability.so")
set(LIBTOKUDB "tokufractaltree" CACHE STRING "Name of libtokufractaltree.so")

set(INSTALL_LIBDIR "lib" CACHE STRING "where to install libs")

if (USE_VALGRIND AND NOT VALGRIND_INCLUDE_DIR MATCHES NOTFOUND)
  include_directories(
    ${VALGRIND_INCLUDE_DIR}
    )
endif()
include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}/portability
  ${CMAKE_CURRENT_SOURCE_DIR}  ## so you can include <ft/ft-ops.h> from inside src/
  ${CMAKE_CURRENT_BINARY_DIR}  ## for logging code
  )
## include where config.h will be generated
include_directories(${CMAKE_CURRENT_BINARY_DIR}/portability)

## build db.h and include where it will be generated
add_subdirectory(buildheader)
include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR}/buildheader)

## default includes and libraries
include_directories(SYSTEM
  /usr/local/include
  ${ZLIB_INCLUDE_DIRS}
  )

## add subdirectories
add_subdirectory(util)
add_subdirectory(portability)
add_subdirectory(ft)
add_subdirectory(locktree)
add_subdirectory(src)
add_subdirectory(ftcxx)
add_subdirectory(tools)

install(
  FILES README.md README-TOKUDB
  DESTINATION .
  COMPONENT tokukv_misc
  )

## build tags
include(TokuBuildTagDatabases)

=== src/third_party/PerconaFT/ft/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

## generate log_code.cc, log_print.cc, log_header.cc
set_source_files_properties(
  "${CMAKE_CURRENT_BINARY_DIR}/log_code"
  "${CMAKE_CURRENT_BINARY_DIR}/log_print"
  "${CMAKE_CURRENT_BINARY_DIR}/log_header.h"
  PROPERTIES GENERATED TRUE)

add_executable(logformat logger/logformat.cc)
target_link_libraries(logformat ${LIBTOKUPORTABILITY}_static)
if (USE_GCOV)
   add_space_separated_property(TARGET logformat LINK_FLAGS --coverage)
endif (USE_GCOV)

add_custom_command(
  OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/log_code.cc"
  OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/log_print.cc"
  OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/log_header.h"
  COMMAND $<TARGET_FILE:logformat> .
  DEPENDS logger/logformat
  )
add_custom_target(
  generate_log_code
  DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/log_code.cc" "${CMAKE_CURRENT_BINARY_DIR}/log_print.cc" "${CMAKE_CURRENT_BINARY_DIR}/log_header.h"
  )

set(FT_SOURCES
  bndata
  cachetable/background_job_manager
  cachetable/cachetable
  cachetable/checkpoint
  cursor
  ft
  ft-cachetable-wrappers
  ft-flusher
  ft-hot-flusher
  ft-ops
  ft-test-helpers
  ft-verify
  loader/callbacks
  loader/dbufio
  loader/loader
  loader/pqueue
  leafentry
  le-cursor
  logger/logcursor
  logger/logfilemgr
  logger/logger
  logger/log_upgrade
  logger/recover
  msg
  msg_buffer
  node
  pivotkeys
  serialize/block_allocator
  serialize/block_allocator_strategy
  serialize/block_table
  serialize/compress
  serialize/ft_node-serialize
  serialize/ft-node-deserialize
  serialize/ft-serialize
  serialize/quicklz
  serialize/sub_block
  txn/rollback
  txn/rollback-apply
  txn/rollback-ct-callbacks
  txn/rollback_log_node_cache
  txn/roll
  txn/txn
  txn/txn_child_manager
  txn/txn_manager
  txn/xids
  ule
  "${CMAKE_CURRENT_BINARY_DIR}/log_code"
  "${CMAKE_CURRENT_BINARY_DIR}/log_print"
  )

add_library(ft SHARED ${FT_SOURCES})
add_library(ft_static STATIC ${FT_SOURCES})
## we're going to link this into libtokudb.so so it needs to have PIC
set_target_properties(ft_static PROPERTIES POSITION_INDEPENDENT_CODE ON)
maybe_add_gcov_to_libraries(ft ft_static)

## depend on other generated targets
add_dependencies(ft install_tdb_h generate_log_code build_lzma)
add_dependencies(ft_static install_tdb_h generate_log_code build_lzma)

## link with lzma (which should be static) and link dependers with zlib
target_link_libraries(ft LINK_PRIVATE util_static lzma ${LIBTOKUPORTABILITY})
target_link_libraries(ft LINK_PUBLIC z)
target_link_libraries(ft_static LINK_PRIVATE lzma)

add_subdirectory(tests)

=== src/third_party/PerconaFT/tools/CMakeLists.txt ===
set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS _GNU_SOURCE DONT_DEPRECATE_ERRNO)

set(tools tokudb_dump tokuftdump tokuft_logprint tdb-recover ftverify ba_replay)
foreach(tool ${tools})
  add_executable(${tool} ${tool})
  add_dependencies(${tool} install_tdb_h)
  target_link_libraries(${tool} ${LIBTOKUDB}_static ft_static z lzma ${LIBTOKUPORTABILITY}_static ${CMAKE_THREAD_LIBS_INIT} ${EXTRA_SYSTEM_LIBS})

  add_space_separated_property(TARGET ${tool} COMPILE_FLAGS -fvisibility=hidden)
endforeach(tool)

# link in math.h library just for this tool.
target_link_libraries(ftverify m)

install(TARGETS tokuftdump DESTINATION bin COMPONENT tokukv_tools)
install(TARGETS tokuft_logprint DESTINATION bin COMPONENT tokukv_tools)

=== debian/changelog ===
percona-server-mongodb (3.0.5-rel0.7rc) unstable; urgency=medium

  * Update to new Percona Server for MongoDB version 3.0.5

 -- Percona Jenkins <jenkins@vps-utopic-x64-01.ci.percona.com>  Mon, 21 Sep 2015 09:45:54 -0400

percona-server-mongodb (3.0.4) UNRELEASED; urgency=medium

  * Initial release. (Closes: #BLD-285)

 -- Alexey Bychko <alexey.bychko@percona.com>  Thu, 23 Jul 2015 14:10:32 +0600

=== debian/control ===
Source: percona-server-mongodb
Maintainer: Alexey Bychko <alexey.bychko@percona.com>
Section: database
Priority: extra
Standards-Version: 3.9.2
Build-Depends: debhelper (>= 9),
               dh-systemd, librocksdb-dev, libsasl2-dev

Package: percona-server-mongodb
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, percona-server-mongodb-mongos, percona-server-mongodb-shell, percona-server-mongodb-server, percona-server-mongodb-tools
Description: This metapackage will install the mongo shell, import/export tools, other client utilities, server software, default configuration, and init.d scripts.
 This package contains high-performance MongoDB replacement from Percona - Percona Server for MongoDB.
 Percona Server for MongoDB is built for scalability, performance and high availability, scaling from single server deployments to large, complex multi-site architectures. 
 By leveraging in-memory computing, Percona Server for MongoDB provides high performance for both reads and writes. 
 Percona Server for MongoDB's native replication and automated failover enable enterprise-grade reliability and operational flexibility.
 .
 Percona Server for MongoDB is an open-source database used by companies of all sizes, across all industries and for a wide variety of applications. 
 It is an agile database that allows schemas to change quickly as applications evolve, while still providing the functionality developers expect from traditional databases,
 such as secondary indexes, a full query language and strict consistency.
 .
 Percona Server for MongoDB has a rich client ecosystem including hadoop integration, officially supported drivers for 10 programming languages and environments, as well as 40 drivers supported by the user community.
 .
 Percona Server for MongoDB features:
 * JSON Data Model with Dynamic Schemas
 * Auto-Sharding for Horizontal Scalability
 * Built-In Replication for High Availability
 * Rich Secondary Indexes, including geospatial
 * TTL indexes
 * Text Search
 * Aggregation Framework & Native MapReduce

Package: percona-server-mongodb-mongos
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: This package contains mongos - the Percona Server for MongoDB sharded cluster query router
 Percona Server for MongoDB is a drop-in high-performance replacement for MongoDB from Percona

Package: percona-server-mongodb-server
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: This package contains the Percona Server for MongoDB server software, default configuration files and init.d scripts
 Percona Server for MongoDB is a drop-in high-performance replacement for MongoDB from Percona

Package: percona-server-mongodb-shell
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: This package contains the Percona Server for MongoDB shell
 Percona Server for MongoDB is a drop-in high-performance replacement for MongoDB from Percona

Package: percona-server-mongodb-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Mongo tools for high-performance MongoDB fork from Percona
 Percona Server for MongoDB is a drop-in high-performance replacement for MongoDB from Percona

Package: percona-server-mongodb-dbg
Architecture: any
Section: debug
Depends: percona-server-mondodb (= ${binary:Version}), ${misc:Depends}
Description: Debugging package for Percona Server for MongoDB
 Percona Server for MongoDB is a drop-in high-performance replacement for MongoDB from Percona

=== debian/rules ===
#!/usr/bin/make -f
#
export DH_VERBOSE=1
export DEB_BUILD_HARDENING=1
export NJOBS=$(shell grep -c processor /proc/cpuinfo)
export PSM_TARGETS=mongod mongos mongo
export PSMSRC=$(CURDIR)
export MONGOTOOLS=bsondump mongostat mongofiles mongoexport mongoimport mongorestore mongodump mongotop mongooplog
export INSTALLDIR=$(PSMSRC)/install
export PORTABLE=1
export TOOLS_TAGS=ssl sasl
#
clean:
	rm -fr $(PSMSRC)/bin
	rm -fr $(INSTALLDIR)
	scons -C $(PSMSRC) -c --variant-dir=percona --audit --release --ssl --opt -j$(NJOBS) --use-sasl-client CPPPATH=$(INSTALLDIR)/include \
	LIBPATH=$(INSTALLDIR)/lib --PerconaFT --rocksdb --wiredtiger --allocator=jemalloc $(PSM_TARGETS)
	rm -fr build
	find $(PSMSRC) -name '*.pyc' -delete
		
PerconaFT: 
	cd $(PSMSRC)/src/third_party/PerconaFT; \
	cmake . -DCMAKE_BUILD_TYPE=Release -DUSE_VALGRIND=OFF -DTOKU_DEBUG_PARANOID=OFF -DBUILD_TESTING=OFF -DCMAKE_INSTALL_PREFIX=/ -DJEMALLOC_SOURCE_DIR=$(PSMSRC)/src/third_party/jemalloc; \
	make -j$(NJOBS); \
	make install DESTDIR=$(INSTALLDIR)	
	
RocksDB:
	cd $(PSMSRC)/src/third_party/rocksdb; \
	make -j$(NJOBS) static_lib; \
	make install-static INSTALL_PATH=${INSTALLDIR}

# Finally PSfMDB
percona-server-mongodb: PerconaFT RocksDB
	scons --variant-dir=percona --audit --release --ssl --opt=on -j$(NJOBS) --use-sasl-client CPPPATH=$(INSTALLDIR)/include LIBPATH=$(INSTALLDIR)/lib --PerconaFT --rocksdb --wiredtiger --allocator=jemalloc $(PSM_TARGETS)

compile-mongo-tools:
	rm -rf $(PSMSRC)/mongo-tools/vendor/pkg
	mkdir -p $(PSMSRC)/bin
	for tool in $(MONGOTOOLS) ; do \
		cd $(PSMSRC)/mongo-tools; \
		. ./set_gopath.sh; \
		go build -a -o $(PSMSRC)/bin/$$tool -tags "${TOOLS_TAGS}" $(PSMSRC)/mongo-tools/$$tool/main/$$tool.go ; \
	done

build: compile-mongo-tools percona-server-mongodb
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	cp -av mongos debian/percona-server-mongodb-mongos/usr/bin
	cp -av mongo debian/percona-server-mongodb-shell/usr/bin
	cp -av mongod debian/percona-server-mongodb-server/usr/sbin
	cp -av debian/percona-server-mongodb-helper.sh debian/percona-server-mongodb-server/usr/bin
	cp -av debian/mongod.conf debian/percona-server-mongodb-server/etc/mongod.conf
	cp -av $(PSMSRC)/bin/* debian/percona-server-mongodb-tools/usr/bin
	dh_systemd_enable --name=mongod
	dh_installinit -a --name=mongod
	dh_installman -a
	dh_installdocs -a

binary: 
	dh_systemd_start
	dh_strip -a --dbg-package=percona-server-mongodb-dbg
	dh_lintian
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

## percona-server-mongodb 3.0.10

=== debian/changelog ===
percona-server-mongodb (3.0.10-1.5) unstable; urgency=medium

  * Update to new Percona Server for MongoDB version 3.0.10

 -- Percona Jenkins <jenkins@vps-trusty-x64-01.ci.percona.com>  Fri, 11 Mar 2016 22:45:27 -0500

=== debian/rules ===
#!/usr/bin/make -f
#
export DH_VERBOSE=1
export DEB_BUILD_HARDENING=1
export NJOBS=$(shell grep -c processor /proc/cpuinfo)
export PSM_TARGETS=mongod mongos mongo
export PSMSRC=$(CURDIR)
export MONGOTOOLS=bsondump mongostat mongofiles mongoexport mongoimport mongorestore mongodump mongotop mongooplog
export INSTALLDIR=$(PSMSRC)/install
export PORTABLE=1
export TOOLS_TAGS=ssl sasl
CC = gcc-4.8
CXX = g++-4.8
#
%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	rm -fr $(PSMSRC)/bin
	rm -fr $(INSTALLDIR)
	scons -C $(PSMSRC) -c --variant-dir=percona --audit --release --ssl --opt --cc=$(CC) --cxx=$(CXX) -j$(NJOBS) --use-sasl-client CPPPATH=$(INSTALLDIR)/include \
	LIBPATH=$(INSTALLDIR)/lib --PerconaFT --rocksdb --wiredtiger --allocator=jemalloc --tokubackup $(PSM_TARGETS)
	rm -fr build
	find $(PSMSRC) -name '*.pyc' -delete

TokuBackup:
	cd $(PSMSRC)/src/third_party/Percona-TokuBackup/backup; \
	CC=$(CC) CXX=$(CXX) cmake . -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/ -DBUILD_STATIC_LIBRARY=ON; \
	make -j$(NJOBS); \
	make install DESTDIR=$(INSTALLDIR)

PerconaFT:
	cd $(PSMSRC)/src/third_party/PerconaFT; \
	CC=$(CC) CXX=$(CXX) cmake . -DCMAKE_BUILD_TYPE=Release -DUSE_VALGRIND=OFF -DTOKU_DEBUG_PARANOID=OFF -DBUILD_TESTING=OFF -DCMAKE_INSTALL_PREFIX=/ -DJEMALLOC_SOURCE_DIR=$(PSMSRC)/src/third_party/jemalloc; \
	make -j$(NJOBS); \
	make install DESTDIR=$(INSTALLDIR)

RocksDB:
	cd $(PSMSRC)/src/third_party/rocksdb; \
	CC=$(CC) CXX=$(CXX) make -j$(NJOBS) static_lib; \
	make install-static INSTALL_PATH=$(INSTALLDIR)

# Finally PSfMDB
percona-server-mongodb:
	scons --variant-dir=percona --audit --release --ssl --opt=on --cc=$(CC) --cxx=$(CXX) -j$(NJOBS) \
	--use-sasl-client CPPPATH=$(INSTALLDIR)/include LIBPATH=$(INSTALLDIR)/lib \
	--PerconaFT --rocksdb --wiredtiger --tokubackup $(PSM_TARGETS)

compile-mongo-tools:
	rm -rf $(PSMSRC)/mongo-tools/vendor/pkg
	mkdir -p $(PSMSRC)/bin
	for tool in $(MONGOTOOLS) ; do \
		cd $(PSMSRC)/mongo-tools; \
		. ./set_gopath.sh; \
		go build -a -o $(PSMSRC)/bin/$$tool -tags "$(TOOLS_TAGS)" $(PSMSRC)/mongo-tools/$$tool/main/$$tool.go ; \
	done

build: compile-mongo-tools PerconaFT RocksDB TokuBackup percona-server-mongodb

override_dh_auto_install:
	dh_auto_install
	cp -av mongos debian/percona-server-mongodb-mongos/usr/bin
	cp -av mongo debian/percona-server-mongodb-shell/usr/bin
	cp -av mongod debian/percona-server-mongodb-server/usr/bin
	cp -av debian/percona-server-mongodb-helper.sh debian/percona-server-mongodb-server/usr/bin
	cp -av debian/mongod.conf debian/percona-server-mongodb-server/etc/mongod.conf
	cp -av $(PSMSRC)/bin/* debian/percona-server-mongodb-tools/usr/bin

override_dh_strip:
	dh_strip -a --dbg-package=percona-server-mongodb-dbg

override_dh_installinit:
	dh_installinit -a --name=mongod

override_dh_systemd_enable:
	dh_systemd_enable --name=mongod

override_dh_systemd_start:
	dh_systemd_start --restart-after-upgrade

## percona-server-mongodb 3.0.12

=== SConstruct ===
--- 
+++ 
@@ -219,8 +219,8 @@
 add_option( "cc-use-shell-environment", "use $CC from shell for C compiler" , 0 , False )
 add_option( "cxx-use-shell-environment", "use $CXX from shell for C++ compiler" , 0 , False )
 add_option( "ld", "linker to use" , 1 , True )
-add_option( "c++11", "enable c++11 support (experimental)", "?", True,
-            type="choice", choices=["on", "off", "auto"], const="on", default="auto" )
+add_option( "c++11", "enable c++11 support (required as of 3.0.5)", "?", True,
+            type="choice", choices=["on"], const="on", default="on" )
 add_option( "disable-minimum-compiler-version-enforcement",
             "allow use of unsupported older compilers (NEVER for production builds)",
             0, False )
@@ -240,6 +240,7 @@
             type="choice", choices=["on", "off"], const="on", default="on")
 add_option( "PerconaFT" , "Enable PerconaFT" , 0 , False )
 add_option( "audit" , "Enable auditing" , 0 , False )
+add_option( "tokubackup", "Enable Hot Backup for the Fractal Tree engine.", 0, False)
 
 # library choices
 js_engine_choices = ['v8-3.12', 'v8-3.25', 'none']
@@ -267,9 +268,6 @@
 
 add_option( "opt", "Enable compile-time optimization", "?", True, "opt",
             type="choice", choices=["on", "off"], const="on" )
-
-add_option( "profiling", "Allow profiling and debugging", "?", True, "profiling",
-            default="on", type="choice", choices=["on", "off"], const="on" )
 
 add_option( "sanitize", "enable selected sanitizers", 1, True, metavar="san1,san2,...sanN" )
 add_option( "llvm-symbolizer", "name of (or path to) the LLVM symbolizer", 1, False, default="llvm-symbolizer" )
@@ -329,3 +327,4 @@
 add_option( "use-new-tools" , "put new tools in the tarball", 0 , False )
 
 add_option( "use-cpu-profiler",
+            "Link against the google-perftools profiler library",

=== debian/changelog ===
percona-server-mongodb (3.0.12-1.7) unstable; urgency=medium

  * Update to new Percona Server for MongoDB version 3.0.12

 -- Percona Jenkins <alexey.bychko@percona.com>  Fri, 24 Jun 2016 02:56:58 -0400

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,7 @@
 #
 export DH_VERBOSE=1
 export DEB_BUILD_HARDENING=1
+export PATH := /usr/local/go/bin:$(PATH)
 export NJOBS=$(shell grep -c processor /proc/cpuinfo)
 export PSM_TARGETS=mongod mongos mongo
 export PSMSRC=$(CURDIR)

## percona-server-mongodb 3.0.15

=== debian/changelog ===
percona-server-mongodb (3.0.15-1.10) unstable; urgency=medium

  * Update to new Percona Server for MongoDB version 3.0.15

 -- Percona Jenkins <jenkins@jenkins-ubuntu-trusty.x64-0ae4f83f-7138-4398-8e02-021edf752930>  Mon, 22 May 2017 09:00:43 -0400

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,9 @@
 Section: database
 Priority: extra
 Standards-Version: 3.9.2
-Build-Depends: debhelper (>= 9),
-               dh-systemd, librocksdb-dev, libsasl2-dev
+Build-Depends: debhelper (>= 9), debconf, libbz2-dev, libsnappy-dev, pkg-config, 
+							 zlib1g-dev, libzlcore-dev, dh-systemd, libsasl2-dev, g++, cmake
+
 
 Package: percona-server-mongodb
 Architecture: any
@@ -57,7 +58,7 @@
 Package: percona-server-mongodb-dbg
 Architecture: any
 Section: debug
-Depends: percona-server-mondodb (= ${binary:Version}), ${misc:Depends}
+Depends: percona-server-mongodb (= ${binary:Version}), ${misc:Depends}
 Description: Debugging package for Percona Server for MongoDB
  Percona Server for MongoDB is a drop-in high-performance replacement for MongoDB from Percona

=== debian/rules ===
--- 
+++ 
@@ -10,6 +10,7 @@
 export INSTALLDIR=$(PSMSRC)/install
 export PORTABLE=1
 export TOOLS_TAGS=ssl sasl
+export PATH := /usr/local/go/bin:$(PATH)
 CC = gcc-4.8
 CXX = g++-4.8
 #
@@ -39,7 +40,7 @@
 
 RocksDB:
 	cd $(PSMSRC)/src/third_party/rocksdb; \
-	CC=$(CC) CXX=$(CXX) make -j$(NJOBS) static_lib; \
+	CC=$(CC) CXX=$(CXX) make OPT=-ULZ4 -j$(NJOBS) static_lib; \
 	make install-static INSTALL_PATH=$(INSTALLDIR)
 
 # Finally PSfMDB
@@ -54,10 +55,11 @@
 	for tool in $(MONGOTOOLS) ; do \
 		cd $(PSMSRC)/mongo-tools; \
 		. ./set_gopath.sh; \
-		go build -a -o $(PSMSRC)/bin/$$tool -tags "$(TOOLS_TAGS)" $(PSMSRC)/mongo-tools/$$tool/main/$$tool.go ; \
+		. ./set_tools_revision.sh; \
+	        go build -a -o $(PSMSRC)/bin/$$tool -ldflags "-X github.com/mongodb/mongo-tools/common/options.Gitspec=$$PSMDB_TOOLS_COMMIT_HASH -X github.com/mongodb/mongo-tools/common/options.VersionStr=$$PSMDB_TOOLS_REVISION" -tags "$(TOOLS_TAGS)" $(PSMSRC)/mongo-tools/$$tool/main/$$tool.go; \
 	done
 
-build: compile-mongo-tools PerconaFT RocksDB TokuBackup percona-server-mongodb
+build: PerconaFT RocksDB TokuBackup percona-server-mongodb compile-mongo-tools
 
 override_dh_auto_install:
 	dh_auto_install
